#include<bits/stdc++.h>
using namespace std;
int n,q,u,v,c,d,e,pom,max1;
int g[80001],a[80001];
vector<int> b[80001];
void bfs(int f)
{
     for(int i=1;i<=n;i++)
    {
       g[i]=-1;
    }
    deque<int> q1;
    q1.push_back(f);
    g[f]=0;
    while(!q1.empty())
    {
        f=q1.front();
        q1.pop_front();
        for(int i=0;i<b[f].size();i++)
        {
            if(g[b[f][i]]==-1){
             q1.push_back(b[f][i]);
             g[b[f][i]]=g[f]+1;
            }
        }
    }
}
int main()
{
    int f;
    cin >> n;
    for(int i=1;i<=n;i++)
    {
        cin >> a[i];
    }
    for(int i=0;i<n-1;i++)
    {
        cin >> u >> v;
        b[u].push_back(v);
        b[v].push_back(u);

    }
    cin >> q;
    for(int i=0;i<q;i++)
    {
        cin >> c;
        if(c==1)
        {
            cin >> d >> e;
            pom=a[d];
            a[d]=a[e];
            a[e]=pom;
        }
        else
        {
            cin >> d >> e >> f;
            bfs(f);
            max1=0;
            for(int j=d;j<=e;j++)
            {
                max1=max(max1,g[a[j]]);
            }
            cout << max1<<endl;
        }
    }
}